define variable stat as INTEGER.
define variable base-search-dir as CHARACTER.
define variable os-dir-separator as CHARACTER.
define variable dir-separator as CHARACTER.
define variable dir-a as CHARACTER.
define variable dir-b as CHARACTER.
define variable dir-c as CHARACTER.
define variable dir-a-dir1 as CHARACTER.
define variable dir-a-dir2 as CHARACTER.
define variable dir-b-dir1 as CHARACTER.
define variable dir-b-dir2 as CHARACTER.
define variable dir-c-dir1 as CHARACTER.
define STREAM s1.
IF OPSYS NE "UNIX" THEN DO:
   os-dir-separator = ";".
   dir-separator = "\\".
END.
ELSE DO:
   os-dir-separator = ":".
   dir-separator = "/".
END.
base-search-dir = "." + dir-separator + "propath-search" + dir-separator.
dir-a = base-search-dir + "dir_a".
dir-b = base-search-dir + "dir_b".
dir-c = base-search-dir + "dir_c".
dir-a-dir1 = base-search-dir + "dir_a" + dir-separator + "dir_1".
dir-a-dir2 = base-search-dir + "dir_a" + dir-separator + "dir_2".
dir-b-dir1 = base-search-dir + "dir_b" + dir-separator + "dir_1".
dir-b-dir2 = base-search-dir + "dir_b" + dir-separator + "dir_2".
dir-c-dir1 = base-search-dir + "dir_c" + dir-separator + "dir_1".


/*Reset PROPATH*/
PROPATH = "." + os-dir-separator.
message "Set PROPATH to empty.".
message "Look for files".
message "The search for lookup.file should return : ?".
message "Found path for lookup.file: " + search( "lookup.file" ).
message "The search for lookup-1.file should return : ?".
message "Found path for lookup-1.file: " + search( "lookup-1.file" ).
message "The search for lookup-2.file should return : ?".
message "Found path for lookup-2.file: " + search( "lookup-2.file" ).
message "The search for lookup-3.file should return : ?".
message "Found path for lookup-3.file: " + search( "lookup-3.file" ).
message "Creating test file structure.".

OS-CREATE-DIR VALUE( base-search-dir ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + base-search-dir + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-a ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-a + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-b ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-b + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-c ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-c + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-a-dir1 ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-a-dir1 + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-a-dir2 ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-a-dir2 + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-b-dir1 ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-b-dir1 + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-b-dir2 ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-b-dir2 + "SYSTEM ERROR # " STAT.

OS-CREATE-DIR VALUE( dir-c-dir1 ).
stat = OS-ERROR.
IF stat NE 0 THEN
   message "Error creating directory: " + dir-c-dir1  + "SYSTEM ERROR # " STAT.

OUTPUT STREAM s1 TO VALUE ( dir-a + dir-separator + "lookup.file" ).
PUT STREAM s1 UNFORMATTED SKIP.
OUTPUT STREAM s1 CLOSE.
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-a + dir-separator + "lookup-2.file").
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-a-dir1 + dir-separator + "lookup-1.file").
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-a-dir2 + dir-separator + "lookup.file").
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-b + dir-separator + "lookup-2.file").
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-b-dir1 + dir-separator + "lookup-1.file").
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-b-dir2 + dir-separator + "lookup.file").
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-c + dir-separator + "lookup-2.file").
OS-COPY VALUE(dir-a + dir-separator + "lookup.file") VALUE(dir-c-dir1 + dir-separator + "lookup-3.file").
PROPATH = base-search-dir + os-dir-separator + 
dir-b-dir1 + os-dir-separator + 
dir-c + os-dir-separator + 
dir-a + os-dir-separator + 
dir-b + os-dir-separator + 
dir-b-dir2 + os-dir-separator + 
dir-a-dir2 + os-dir-separator + 
dir-a-dir1 + os-dir-separator.

message "The search for this_file_doesnot_exist.file should return : ?".
message "Found path for lookup.file: " + search( "this_file_doesnot_exist.file" ).
message "The search for lookup.file should return : ./propath-search/dir_a/lookup.file".
message "Found path for lookup.file: " + search( "lookup.file" ).
message "The search for lookup-1.file should return : ./propath-search/dir_b/dir_1/lookup-1.file".
message "Found path for lookup-1.file: " + search( "lookup-1.file" ).
message "The search for lookup-2.file should return : ./propath-search/dir_c/lookup-2.file".
message "Found path for lookup-2.file: " + search( "lookup-2.file" ).
message "The search for lookup-3.file should return : ?".
message "Found path for lookup-3.file: " + search( "lookup-3.file" ).
/*Cleanup test*/
OS-DELETE VALUE( base-search-dir ) RECURSIVE.